local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local ScarfPriority = function(player)
			if player.mo.swordstate > 1
				CBW_Battle.SetPriority(player,1,0,nil,1,0,"Scarf Sword")
			end
			if player.mo.sworddash > 1
				CBW_Battle.SetPriority(player,1,0,nil,1,0,"Float Dash")
			end
		end
		local ScarfBattle = function(mo,doaction,pressedaction)
		local player = mo.player
		if not(CBW_Battle.CanDoAction(player))
			player.actionstate = 0
			return
		end
		if P_IsObjectOnGround(mo)
			player.actiontext = "Light Burst"
			player.actionrings = 10	
		else
			player.actiontext = "Plasma Shot"
			player.actionrings = 10
		end
		if player.actionstate != 0
			player.canguard = false
		end
		if player.actionstate == 0
		and not player.mo.scarfplasmabattle
		and not player.mo.swordstate
			if doaction == 1
				if P_IsObjectOnGround(mo)
					S_StartSound(mo, sfx_s3k78)
					S_StartSound(mo, sfx_s3k60)
					player.mo.lightburst = 31
					S_StartSound(player.mo, sfx_s3k5f)
					P_SpawnPlayerMissile(mo, MT_LIGHTBURST)
					CBW_Battle.PayRings(player)
					player.mo.state = S_PLAY_LIGHTBURST1
					player.mo.swordstate = 0
					player.mo.swordjump = 0
					player.mo.sworddash = 0
					CBW_Battle.ApplyCooldown(player,TICRATE*2)
					if player.mo.state != S_PLAY_LIGHTBURST1
					and player.mo.lightburst > 1
						player.mo.state = S_PLAY_LIGHTBURST1
					end
				else
					if not P_IsObjectOnGround(mo)
						CBW_Battle.PayRings(player)
						S_StartSound(mo,sfx_s3k7a)
						player.mo.scarfplasmabattle = 1*TICRATE
						CBW_Battle.ApplyCooldown(player, 2*TICRATE)
					end
				end
			end
		end
		if player.mo.lightburst > 1
			player.canguard = false
			if player.mo.lightburst == 1
				player.canguard = true
			end
		elseif player.mo.swordstate > 1
			player.canguard = false
			if player.mo.swordstate == 1
				player.canguard = true
			end
		elseif player.mo.sworddash > 1
			player.canguard = false
			if player.mo.sworddash == 1
				player.canguard = true
			end
		elseif player.mo.swordjump > 1
			player.canguard = false
			if player.mo.swordjump == 1
				player.canguard = true
			end
		end
	end
	CBW_Battle.SkinVars["scarf"] = {
		flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
		weight = 100,
		shields = 1,
		special = ScarfBattle,
		func_collide = TDCollide,
		func_priority_ext = ScarfPriority
	}
	print("Scarf The Wolf Battle Mode support has been added!")
end)